#!/usr/bin/perl -w
;### MTGooglePageRank ǻѤ PageRank ǡ١򹹿
;#			Original Copyright (c) 2006 Piroli YUKARINOMIYA
;#			Open MagicVox.net - http://www.magicvox.net/
;#			@see http://www.magicvox.net/archive/2006/04151455.php


my ($MYDIR);
BEGIN {
	$MYDIR = ($0 =~ m!(.*[/\\])!) ? $1 : './';
	unshift @INC, $MYDIR;
}

use strict;
use Fcntl ':flock';
use WWW::Google::PageRank;
;#use Data::Dumper;#DEBUG


;### PageRank ǡ١եꤷޤ
;### MTGooglePageRank ץ饰ǻꤷѥƱˤޤХѥ⡣
use constant INDEX_DATABASE => '/home/pass/to/your/cache/file/db-index.txt';

;### ٤μ¹Ԥ Google  PageRank 䤤碌Ǥ
;### 礭᤮ Google ܤ뤫⤷ޤ
;### ᤮ꥵȤǤ PageRank ֤˹ʤ⤷ޤ
use constant MAX_NUMBER_QUERY		=> 30;

;### 礻餳ǻꤵ줿ְʾвᤷƤ PageRank ޤ
;### ˤưΤǤ̵ʤΤǡ콵٤ǽʬȡ
use constant ITEM_REFRESH_SPAN		=> 60 * 60 * 24 * 7;# []


print "Content-type: text/plain; charset=euc-jp\n\n";
print "* MTGooglePageRank - updating the indexes of Google PageRank\n\n";


print "* Starting process ...\n";
my $google_pr = WWW::Google::PageRank->new;
if ($google_pr) {
	my $query_count = MAX_NUMBER_QUERY;

	my @db1;
	my @db2;
	my $need_update = 0;

	print "* Reading: ". INDEX_DATABASE. " ...";
	if (open DB_FILE, '<'. INDEX_DATABASE)
	{
		flock DB_FILE, LOCK_SH;
		@db1 = ();
		@db2 = ();
		while (<DB_FILE>) {
			s/[\r\n]*$//;
			int(rand(2)) ? (unshift @db1, $_) : (push @db1, $_);
		}
		flock DB_FILE, LOCK_UN;
		close DB_FILE;
		print "done.\n";


		print "* Retrieve PageRank of the un-touched URL ...\n";
		@db2 = ();
		foreach my $que (@db1) {
			my ($url, $t, $pr) = split /\t/, $que;
			if ($query_count && !defined $t) {
				print $url. "\n";
				my $ret = $google_pr->get ($url);
				if (defined $ret) {
					print "\tSucceeded. PageRank is $ret\n";
					$que = $url. "\t". time (). "\t". $ret;
				} else {
					print "\tFailed. \n";
					$que = $url. "\t". time ();
				}
				$need_update = 1;
				$query_count--;
			}
			int(rand(2)) ? (unshift @db2, $que) : (push @db2, $que);
		}
		@db1 = ();
		print "done.\n";


		if ($query_count) {
			@db1 = ();
			print "* Retrieve PageRank of the un-solved URL ...\n";
			foreach my $que (@db2) {
				my ($url, $t, $pr) = split /\t/, $que;
				if ($query_count && !defined $pr) {
					print $url. "\n";
					my $ret = $google_pr->get ($url);
					if (defined $ret) {
						print "\tSucceeded. PageRank is $ret\n";
						$que = $url. "\t". time (). "\t". $ret;
					} else {
						print "\tFailed. \n";
						$que = $url. "\t". time ();
					}
					$need_update = 1;
					$query_count--;
				}
				int(rand(2)) ? (unshift @db1, $que) : (push @db1, $que);
			}
			@db2 = ();
			print "done\n";


			if ($query_count) {
				@db2 = ();
				print "* Refresh the old PageRank of the URL ...\n";
				foreach my $que (@db1) {
					my ($url, $t, $pr) = split /\t/, $que;
					if ($query_count && $t + ITEM_REFRESH_SPAN < time ()) {
						print $url. "\n";
						my $ret = $google_pr->get ($url);
						if (defined $ret) {
							print "\tSucceeded. PageRank is refreshed to $ret\n";
							$que = $url. "\t". time (). "\t". $ret;
						} else {
							print "\tFailed. PageRank stays hold.\n";
						}
						$need_update = 1;
						$query_count--;
					}
					int(rand(2)) ? (unshift @db2, $que) : (push @db2, $que);
				}
				@db1 = ();
				print "done\n";
			}
		}

		if ($need_update)
		{
			print "* Write back to ". INDEX_DATABASE. " ...";
			if (open DB_FILE, '+>'. INDEX_DATABASE)
			{
				flock DB_FILE, LOCK_EX;
				seek DB_FILE, 0,0;
				truncate DB_FILE, 0;
				if (scalar @db1) { foreach (@db1) { print DB_FILE $_. "\n"; } }
				if (scalar @db2) { foreach (@db2) { print DB_FILE $_. "\n"; } }
				flock DB_FILE, LOCK_UN;
				close DB_FILE;
				print "done.\n";
			}
			else {
				print "\n\tCould not open the file. Abnormal teminated.\n";
			}
		}
		else {
			print "* No need to update the indexes.\n";
		}
	}
	else {
		print "\n\tCould not open the file. Abnormal teminated.\n";
	}
}
else {
	print "\tInitialize failure - WWW::Google::PageRank\n";
}
